// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;
using System.Collections;
using System.Reflection;
using System.Runtime.InteropServices;

namespace Python.Runtime {

    /// <summary>
    /// Implements a Python type for managed arrays. This type is essentially
    /// the same as a ClassObject, except that it provides sequence semantics 
    /// to support natural array usage (indexing) from Python.
    /// </summary>

    internal class ArrayObject : ClassBase {

	internal ArrayObject(Type tp) : base(tp) {}

	internal override bool CanSubclass() {
	    return false;
	}

	[CallConvCdecl()]
	public static IntPtr tp_new(IntPtr ob, IntPtr args, IntPtr kw) {
	    Exceptions.SetError(Exceptions.TypeError,
				"cannot instantiate array wrapper"
				);
	    return IntPtr.Zero;
	}

	[CallConvCdecl()]
	public static IntPtr tp_init(IntPtr ob, IntPtr args, IntPtr kw) {
	    Exceptions.SetError(Exceptions.TypeError,
				"cannot instantiate array wrapper"
				);
	    return IntPtr.Zero;
	}

	/*
	[CallConvCdecl()]
	public static IntPtr tp_repr(IntPtr ob) {
	    ArrayObject self = (ArrayObject)GetManagedObject(ob);
	    string s = String.Format("<array '{0}'>", self.type.Name);
	    return Runtime.PyString_FromStringAndSize(s, s.Length);
	}
	*/

    }	

}
