// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;
using System.Collections;
using System.Reflection;
using System.Runtime.InteropServices;

namespace Python.Runtime {


    internal class CLRObject : ManagedType {

	internal Object inst;

	internal CLRObject(Object ob, IntPtr pyType) : base() {
	    PyObjectHead pyObj = new PyObjectHead();
	    this.gcHandle = GCHandle.Alloc(this);
	    pyObj.ob_data = (IntPtr) this.gcHandle;
	    pyObj.ob_refcnt = (IntPtr) 0;
	    pyObj.ob_type = pyType;
	    this.tpHandle = pyType;
	    Runtime.Incref(pyType); //??

	    this.pyHandle = Runtime.PyMem_Malloc((4 * IntPtr.Size));
	    Marshal.StructureToPtr(pyObj, this.pyHandle, false);
	    inst = ob;
	}


	// todo: caching of ref types?
	internal static CLRObject GetInstance(Object ob, IntPtr pyType) {
	    return new CLRObject(ob, pyType);
	}

	internal static CLRObject GetInstance(Object ob) {
	    ClassBase cc = ClassManager.GetClass(ob.GetType());
	    return GetInstance(ob, cc.tpHandle);
	}

	internal static IntPtr GetInstHandle(Object ob, IntPtr pyType) {
	    CLRObject co = GetInstance(ob, pyType);
	    return co.pyHandle;
	}

	internal static IntPtr GetInstHandle(Object ob, Type type) {
	    ClassBase cc = ClassManager.GetClass(type);
	    CLRObject co = GetInstance(ob, cc.tpHandle);
	    return co.pyHandle;
	}


	internal static IntPtr GetInstHandle(Object ob) {
	    CLRObject co = GetInstance(ob);
	    return co.pyHandle;
	}


    }


}

