// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;
using System.Collections;
using System.Reflection;
using System.Security.Permissions;

namespace Python.Runtime {

    //========================================================================
    // Implements a Python descriptor type that manages CLR indexers.
    //========================================================================

    // TODO: not started yet!!

    internal class IndexerObject : ExtensionType {

	PropertyInfo info;
	MethodInfo getter;
	MethodInfo setter;

	[StrongNameIdentityPermissionAttribute(SecurityAction.Assert)]
	public IndexerObject(PropertyInfo md) : base() {
	    getter = md.GetGetMethod(true);
	    setter = md.GetSetMethod(true);
	    info = md;
	}


	//====================================================================
	// Descriptor __repr__ implementation.
	//====================================================================

	[CallConvCdecl()]
	public static IntPtr tp_repr(IntPtr ob) {
	    IndexerObject self = (IndexerObject)GetManagedObject(ob);
	    string s = String.Format("<indexer '{0}'>", self.info.Name);
	    return Runtime.PyString_FromStringAndSize(s, s.Length);
	}

    }


}
