// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;
using System.Runtime.InteropServices;

namespace Python.Runtime {


    public class PyFloat : PyNumber {

	public PyFloat(IntPtr pointer) : base(pointer) {}

	public PyFloat(double value) : base(IntPtr.Zero) {
	    handle = Runtime.PyFloat_FromDouble(value);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

	public PyFloat(string value) : base(IntPtr.Zero) {
	    PyString pyStr = new PyString(value);
	    handle = Runtime.PyFloat_FromString(pyStr.handle, IntPtr.Zero);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

    }


}
