// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;
using System.Runtime.InteropServices;

namespace Python.Runtime {


    public class PyLong : PyNumber {

	public PyLong(IntPtr pointer) : base(pointer) {}

	public PyLong(int value) : base(IntPtr.Zero) {
	    handle = Runtime.PyLong_FromLong((long)value);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

	public PyLong(long value) : base(IntPtr.Zero) {
	    handle = Runtime.PyLong_FromLong(value);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

	public PyLong(double value) : base(IntPtr.Zero) {
	    handle = Runtime.PyLong_FromDouble(value);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

	public PyLong(string value) : base(IntPtr.Zero) {
	    handle = Runtime.PyLong_FromString(value, IntPtr.Zero, 0);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

    }


}
