// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;

namespace Python.Runtime {


    public class PyModule : PyObject {

	public PyModule(IntPtr pointer) : base(pointer){
	}

	public string Filename {
	    get {
		return Runtime.PyModule_GetFilename(handle);
	    }
	}

	public string Name {
	    get {
		return Runtime.PyModule_GetName(handle);
	    }
	}

	public PyDict GetDict() {
	    IntPtr result = Runtime.PyModule_GetDict(handle);
	    if (result == IntPtr.Zero) {
		throw new PythonException();
	    }
	    Runtime.Incref(result);
	    return new PyDict(result);
	}

    }


}
