// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;
using System.Runtime.InteropServices;

namespace Python.Runtime {


    public class PyNumber : PyObject {

	public PyNumber(IntPtr pointer) : base(pointer) {}


	// Conversions to Python types

	public PyInteger ToPyInteger() {
	    IntPtr result = Runtime.PyNumber_Int(handle);
	    if (result == IntPtr.Zero) {
		throw new PythonException();
	    }
	    return new PyInteger(result);
	}

	public PyLong ToPyLong() {
	    IntPtr result = Runtime.PyNumber_Long(handle);
	    if (result == IntPtr.Zero) {
		throw new PythonException();
	    }
	    return new PyLong(result);
	}

	public PyFloat ToPyFloat() {
	    IntPtr result = Runtime.PyNumber_Float(handle);
	    if (result == IntPtr.Zero) {
		throw new PythonException();
	    }
	    return new PyFloat(result);
	}

    }


}
