// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;

namespace Python.Runtime {


    public class PyString : PySequence {

	public PyString(IntPtr pointer) : base(pointer) {}

	public PyString(string value) : base(IntPtr.Zero) {
	    handle = Runtime.PyString_FromStringAndSize(value, value.Length);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}

	public override int Length {
	    get {
		return Runtime.PyString_Size(handle);
	    }
	}

	public override string ToString() {
	    return Runtime.PyString_AsString(handle);
	}

    }


}
