// Copyright (c) 2001, 2002 Zope Corporation and Contributors.
//
// All Rights Reserved.
//
// This software is subject to the provisions of the Zope Public License,
// Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
// WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
// FOR A PARTICULAR PURPOSE.

using System;

namespace Python.Runtime {




    public class PyTuple : PySequence {

	public PyTuple(IntPtr pointer) : base(pointer) {}

	public PyTuple() : base(IntPtr.Zero) {
	    handle = Runtime.PyTuple_New(0);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	}
	
	public static PyTuple Empty;

	public PyTuple(PyObject[] items) : base(IntPtr.Zero) {
	    int size = items.Length;
	    int result;

	    handle = Runtime.PyTuple_New(size);
	    if (handle == IntPtr.Zero) {
		throw new PythonException();
	    }
	    for (int i = 0; i < size; i++) {
		Runtime.Incref(items[i].handle);
		result = Runtime.PyTuple_SetItem(handle, i, items[i].handle);
		if (result < 0) {
		    throw new PythonException();
		}
	    }
	}




	public override void SetItem(int index, PyObject item) {
	    Runtime.Incref(item.handle);
	    int result = Runtime.PyTuple_SetItem(handle, index, item.Handle);
	    if (result < 0) {
		throw new PythonException();
	    }
	}

    }


}
