// RuntimeTests.cs - Unit tests for the Python.Runtime assembly
//
// Author:  Brian Lloyd <brian@zope.com>
//
// (c) 2002 Brian Lloyd

using NUnit.Framework;
using System;

namespace Python.Runtime.Tests {


public class AllTests : TestCase {

    public AllTests(string name) : base(name) {}
    
    public static ITest Suite {
	get {
	    TestSuite suite = new TestSuite();
	    suite.AddTest(InterpreterTests.Suite);
	    suite.AddTest(PyIntegerTests.Suite);
	    suite.AddTest(CallableTests.Suite);
	    suite.AddTest(PyModuleTests.Suite);
	    suite.AddTest(PyStringTests.Suite);
	    suite.AddTest(PyTupleTests.Suite);
	    suite.AddTest(PyListTests.Suite);
	    suite.AddTest(PyDictTests.Suite);

	    return suite;
	}
    }

}


} // Python.Runtime.Tests
