// CallableTests.cs - Unit tests for callable Python objects
//
// Author:  Brian Lloyd <brian@zope.com>
//
// (c) 2002 Brian Lloyd

using NUnit.Framework;
using Python.Runtime;
using System;

namespace Python.Runtime.Tests {


public class CallableTests : TestCase {

    public CallableTests(string name) : base(name) {}
    
    public static ITest Suite {
	get {
	    return new TestSuite(typeof(CallableTests));
	}
    }

    protected override void SetUp() {
	PythonInterpreter.Initialize();
    }

    protected override void TearDown() {	
	PythonInterpreter.Finalize();
    }


    // Actual test cases start here.

    public void TestModuleFunctions() {
	PyModule module = PythonInterpreter.ImportModule("sys");

	PyObject method = module.GetAttr("exc_info");
	PyObject result = method.Invoke();
	Assert("call 1 failed", result.Length == 3);

	/*
	PyString spam = new PyString("spam");
	PyString eggs = new PyString("eggs");

	PyObject[2] args = {spam, eggs};

	result = function.Invoke(args);
	Assert("call 1 failed", result.ToString() == "spam");


	result = function.Invoke(value);
	Assert("call 2 failed", result.ToString() == "spam");
	*/
    }
    

}


} // Python.Runtime.Tests
