# Copyright (c) 2001, 2002 Zope Corporation and Contributors.
#
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.

import sys, os, string, unittest, types
from CLR.Python.Test import EventTest

class EventTests(unittest.TestCase):
    """Test CLR event support."""

    def testPublicInstanceEvent(self):
        """Test public instance events."""
        pass


##     def testPublicStaticField(self):
##         """Test public static fields."""
##         object = TestClass();

##         self.failUnless(TestClass.PublicStaticField == 'public')
##         TestClass.PublicStaticField = 'changed'
##         self.failUnless(TestClass.PublicStaticField == 'changed')

##         self.failUnless(object.PublicStaticField == 'changed')
##         object.PublicStaticField = 'public'
##         self.failUnless(object.PublicStaticField == 'public')

##         def test():
##             del TestClass.PublicStaticField

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass().PublicStaticField

##         self.failUnlessRaises(TypeError, test)

##     def testProtectedInstanceField(self):
##         """Test protected instance fields."""
##         object = TestClass();

##         self.failUnless(object.ProtectedField == 'protected')
##         object.ProtectedField = 'changed'
##         self.failUnless(object.ProtectedField == 'changed')

##         def test():
##             del TestClass().ProtectedField

##         self.failUnlessRaises(TypeError, test)

##     def testProtectedStaticField(self):
##         """Test protected static fields."""
##         object = TestClass();

##         self.failUnless(TestClass.ProtectedStaticField == 'protected')
##         TestClass.ProtectedStaticField = 'changed'
##         self.failUnless(TestClass.ProtectedStaticField == 'changed')

##         self.failUnless(object.ProtectedStaticField == 'changed')
##         object.ProtectedStaticField = 'protected'
##         self.failUnless(object.ProtectedStaticField == 'protected')

##         def test():
##             del TestClass.ProtectedStaticField

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass().ProtectedStaticField

##         self.failUnlessRaises(TypeError, test)

##     def testReadOnlyInstanceField(self):
##         """Test readonly instance fields."""
##         self.failUnless(TestClass().ReadOnlyField == 'readonly')

##         def test():
##             TestClass().ReadOnlyField = 'changed'

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass().ReadOnlyField

##         self.failUnlessRaises(TypeError, test)

##     def testReadOnlyStaticField(self):
##         """Test readonly static fields."""
##         object = TestClass();

##         self.failUnless(TestClass.ReadOnlyStaticField == 'readonly')
##         self.failUnless(object.ReadOnlyStaticField == 'readonly')

##         def test():
##             TestClass.ReadOnlyStaticField = 'changed'

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             TestClass().ReadOnlyStaticField = 'changed'

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass.ReadOnlyStaticField

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass().ReadOnlyStaticField

##         self.failUnlessRaises(TypeError, test)

##     def testConstantField(self):
##         """Test const fields."""
##         object = TestClass();

##         self.failUnless(TestClass.ConstField == 'const')
##         self.failUnless(object.ConstField == 'const')

##         def test():
##             TestClass().ConstField = 'changed'

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             TestClass.ConstField = 'changed'

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass().ConstField

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             del TestClass.ConstField

##         self.failUnlessRaises(TypeError, test)

##     def testInternalField(self):
##         """Test internal fields."""

##         def test():
##             f = TestClass().InternalField

##         self.failUnlessRaises(AttributeError, test)

##         def test():
##             f = TestClass().InternalStaticField

##         self.failUnlessRaises(AttributeError, test)

##         def test():
##             f = TestClass.InternalStaticField

##         self.failUnlessRaises(AttributeError, test)

##     def testPrivateField(self):
##         """Test private fields."""

##         def test():
##             f = TestClass().PrivateField

##         self.failUnlessRaises(AttributeError, test)

##         def test():
##             f = TestClass().PrivateStaticField

##         self.failUnlessRaises(AttributeError, test)

##         def test():
##             f = TestClass.PrivateStaticField

##         self.failUnlessRaises(AttributeError, test)

##     def testFieldDescriptorGetSet(self):
##         """Test field descriptor get / set."""

##         # This test ensures that setting an attribute implemented with
##         # a descript actually goes through the descriptor (rather than
##         # silently replacing the descriptor in the instance or type dict.

##         object = TestClass()

##         self.failUnless(TestClass.PublicStaticField == 'public')
##         self.failUnless(object.PublicStaticField == 'public')

##         descriptor = TestClass.__dict__['PublicStaticField']
##         self.failUnless(type(descriptor) != types.StringType)

##         object.PublicStaticField = 'public'
##         descriptor = TestClass.__dict__['PublicStaticField']
##         self.failUnless(type(descriptor) != types.StringType)

##         TestClass.PublicStaticField = 'public'
##         descriptor = TestClass.__dict__['PublicStaticField']
##         self.failUnless(type(descriptor) != types.StringType)

##     def testFieldDescriptorWrongType(self):
##         """Test setting a field using a value of the wrong type."""
##         def test():
##             TestClass().PublicField = 0

##         self.failUnlessRaises(TypeError, test)

##     def testFieldDescriptorAbuse(self):
##         """Test field descriptor abuse."""
##         desc = TestClass.__dict__['PublicField']

##         def test():
##             desc.__get__(0, 0)

##         self.failUnlessRaises(TypeError, test)

##         def test():
##             desc.__set__(0, 0)

##         self.failUnlessRaises(TypeError, test)



def test_suite():
    return unittest.makeSuite(EventTests)

def main():
    unittest.TextTestRunner().run(test_suite())

if __name__ == '__main__':
    testcase.setup()
    main()

